// CalcProbDoc.h : CCalcProbDoc NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NETDOC_H__ADD5AFEC_6EA8_11D3_94D0_20B84DC10001__INCLUDED_)
#define AFX_NETDOC_H__ADD5AFEC_6EA8_11D3_94D0_20B84DC10001__INCLUDED_

#include "DlgOption.h"	// ClassView ɂĒǉ܂B
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "graph.h"
#include "data.h"
#include <set>

typedef graph<CNode,CArc> CGraph;
typedef set<CGraph::node_iterator,CGraph::less_node_iterator> CSelNode;
typedef set<CGraph::arc_iterator,CGraph::less_arc_iterator> CSelArc;
int NSize(CGraph& grp);

class CCalcProbDoc : public CDocument
{
protected: // VACY@\݂̂쐬܂B
	CCalcProbDoc();
	DECLARE_DYNCREATE(CCalcProbDoc)

// Agr[g
private:
	int				m_ver;		// t@C̃o[W
	double			m_rate;		// \{
	CSelNode		m_selN;		// Im[h
	CSelArc			m_selA;		// IA[N
	CDlgOption		m_opt;		// IvV
	list<CGraph>	m_data;		// Ot̃Xg
	list<CGraph>::iterator	m_cur;	// ݂̈ʒu
	CBitmap			m_bkbm;		// wirbg}bv

// Iy[V
public:
	enum {UndoSize = 20/* Undoobt@TCY */};
	CGraph& Graph(){return *m_cur;}
	const CGraph& Graph()const{return *m_cur;}
	void Clone(int i);	// Undoobt@ɃN[쐬Bi:Undoobt@TCY
	void Clear(){m_data.clear(); m_data.push_back(CGraph());
		m_cur = m_data.begin(); m_selN.clear(); m_selA.clear();}

	double GetRate()const{return m_rate;}
	void SetRate(double r){m_rate = r;}
	CSelNode& SelNode(){return m_selN;}
	CSelArc& SelArc(){return m_selA;}
	CDlgOption& DlgOption(){return m_opt;}
	CBitmap& GetBkBitmap(){return m_bkbm;}
	void SetBkBitmap();		// wi̐ݒ
	CSize DocSize();		// hLgTCY
	CSize ViewSize();		// \TCY
	void SetModify(bool bCalc /* ČvZ */);	// XVݒ
	void Calc();
	void ResetArc();

//I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CCalcProbDoc)
	public:
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CCalcProbDoc();
	static int s_currentVersion;	// ݂̃o[W
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CCalcProbDoc)
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditRedo(CCmdUI* pCmdUI);
	afx_msg void OnEditUndo();
	afx_msg void OnEditRedo();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_NETDOC_H__ADD5AFEC_6EA8_11D3_94D0_20B84DC10001__INCLUDED_)
